// Code generated by goa v3.14.1, DO NOT EDIT.
//
// health client HTTP transport
//
// Command:
// $ goa gen github.com/PingCAP-QE/ee-apps/dl/design

package client

import (
	"context"
	"net/http"

	goahttp "goa.design/goa/v3/http"
	goa "goa.design/goa/v3/pkg"
)

// Client lists the health service endpoint HTTP clients.
type Client struct {
	// Healthz Doer is the HTTP client used to make requests to the healthz
	// endpoint.
	HealthzDoer goahttp.Doer

	// Livez Doer is the HTTP client used to make requests to the livez endpoint.
	LivezDoer goahttp.Doer

	// RestoreResponseBody controls whether the response bodies are reset after
	// decoding so they can be read again.
	RestoreResponseBody bool

	scheme  string
	host    string
	encoder func(*http.Request) goahttp.Encoder
	decoder func(*http.Response) goahttp.Decoder
}

// NewClient instantiates HTTP clients for all the health service servers.
func NewClient(
	scheme string,
	host string,
	doer goahttp.Doer,
	enc func(*http.Request) goahttp.Encoder,
	dec func(*http.Response) goahttp.Decoder,
	restoreBody bool,
) *Client {
	return &Client{
		HealthzDoer:         doer,
		LivezDoer:           doer,
		RestoreResponseBody: restoreBody,
		scheme:              scheme,
		host:                host,
		decoder:             dec,
		encoder:             enc,
	}
}

// Healthz returns an endpoint that makes HTTP requests to the health service
// healthz server.
func (c *Client) Healthz() goa.Endpoint {
	var (
		decodeResponse = DecodeHealthzResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildHealthzRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.HealthzDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("health", "healthz", err)
		}
		return decodeResponse(resp)
	}
}

// Livez returns an endpoint that makes HTTP requests to the health service
// livez server.
func (c *Client) Livez() goa.Endpoint {
	var (
		decodeResponse = DecodeLivezResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildLivezRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.LivezDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("health", "livez", err)
		}
		return decodeResponse(resp)
	}
}
