// Code generated by goa v3.14.1, DO NOT EDIT.
//
// ks3 client HTTP transport
//
// Command:
// $ goa gen github.com/PingCAP-QE/ee-apps/dl/design

package client

import (
	"context"
	"net/http"

	ks3 "github.com/PingCAP-QE/ee-apps/dl/gen/ks3"
	goahttp "goa.design/goa/v3/http"
	goa "goa.design/goa/v3/pkg"
)

// Client lists the ks3 service endpoint HTTP clients.
type Client struct {
	// DownloadObject Doer is the HTTP client used to make requests to the
	// download-object endpoint.
	DownloadObjectDoer goahttp.Doer

	// RestoreResponseBody controls whether the response bodies are reset after
	// decoding so they can be read again.
	RestoreResponseBody bool

	scheme  string
	host    string
	encoder func(*http.Request) goahttp.Encoder
	decoder func(*http.Response) goahttp.Decoder
}

// NewClient instantiates HTTP clients for all the ks3 service servers.
func NewClient(
	scheme string,
	host string,
	doer goahttp.Doer,
	enc func(*http.Request) goahttp.Encoder,
	dec func(*http.Response) goahttp.Decoder,
	restoreBody bool,
) *Client {
	return &Client{
		DownloadObjectDoer:  doer,
		RestoreResponseBody: restoreBody,
		scheme:              scheme,
		host:                host,
		decoder:             dec,
		encoder:             enc,
	}
}

// DownloadObject returns an endpoint that makes HTTP requests to the ks3
// service download-object server.
func (c *Client) DownloadObject() goa.Endpoint {
	var (
		decodeResponse = DecodeDownloadObjectResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildDownloadObjectRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.DownloadObjectDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("ks3", "download-object", err)
		}
		res, err := decodeResponse(resp)
		if err != nil {
			resp.Body.Close()
			return nil, err
		}
		return &ks3.DownloadObjectResponseData{Result: res.(*ks3.DownloadObjectResult), Body: resp.Body}, nil
	}
}
