// Code generated by goa v3.14.1, DO NOT EDIT.
//
// ks3 service
//
// Command:
// $ goa gen github.com/PingCAP-QE/ee-apps/dl/design

package ks3

import (
	"context"
	"io"

	goa "goa.design/goa/v3/pkg"
)

// OCI artifacts download service
type Service interface {
	// DownloadObject implements download-object.
	DownloadObject(context.Context, *DownloadObjectPayload) (res *DownloadObjectResult, body io.ReadCloser, err error)
}

// ServiceName is the name of the service as defined in the design. This is the
// same value that is set in the endpoint request contexts under the ServiceKey
// key.
const ServiceName = "ks3"

// MethodNames lists the service method names as defined in the design. These
// are the same values that are set in the endpoint request contexts under the
// MethodKey key.
var MethodNames = [1]string{"download-object"}

// DownloadObjectPayload is the payload type of the ks3 service download-object
// method.
type DownloadObjectPayload struct {
	// bucket name
	Bucket string
	// object key
	Key string
}

// DownloadObjectResult is the result type of the ks3 service download-object
// method.
type DownloadObjectResult struct {
	// Length is the downloaded content length in bytes.
	Length int64
	// Content-Disposition header for downloading
	ContentDisposition string
}

// MakeInvalidFilePath builds a goa.ServiceError from an error.
func MakeInvalidFilePath(err error) *goa.ServiceError {
	return goa.NewServiceError(err, "invalid_file_path", false, false, false)
}

// MakeInternalError builds a goa.ServiceError from an error.
func MakeInternalError(err error) *goa.ServiceError {
	return goa.NewServiceError(err, "internal_error", false, false, false)
}
